export declare class ArrayTools {
    static filter<T>(array: Array<T>, criteria: (item: T) => boolean): Array<T>;
    static delete<T>(item: T, array: T[]): void;
    static add<T>(item: T, array: T[]): void;
    static clear<T>(array: T[]): void;
    static insertAfter<T>(index: number, item: T, array: T[]): void;
    static insertBefore<T>(index: number, item: T, array: T[]): void;
    static anyOfFirstIsInSecond<T>(firstArray: T[], secondArray: T[]): boolean;
    static allOfFirstIsInSecond<T>(firstArray: T[], secondArray: T[]): boolean;
    static canMoveUp<T>(item: T, array: T[]): boolean;
    static canMoveDown<T>(item: T, array: T[]): boolean;
    static moveUp<T>(item: T, array: T[]): void;
    static moveDown<T>(item: T, array: T[]): void;
}
